#ifndef REP_TIMEMODEL_SOURCE_H
#define REP_TIMEMODEL_SOURCE_H

// This is an autogenerated file.
// Do not edit this file, any changes made will be lost the next time it is generated.

#include <QtCore/qobject.h>
#include <QtCore/qdatastream.h>
#include <QtCore/qvariant.h>
#include <QtCore/qmap.h>
#include <QtCore/qmetatype.h>

#include <QtRemoteObjects/qremoteobjectnode.h>
#include <QtRemoteObjects/qremoteobjectsource.h>

#include <QtCore>

using namespace Qt::Literals::StringLiterals;

class PresetInfo
{
    Q_GADGET

    Q_PROPERTY(int presetNumber READ presetNumber WRITE setPresetNumber)
    Q_PROPERTY(float frequency READ frequency WRITE setFrequency)
    Q_PROPERTY(QString stationName READ stationName WRITE setStationName)
public:
    PresetInfo() : m_presetNumber(), m_frequency(), m_stationName() {}
    explicit PresetInfo(int presetNumber, float frequency, QString stationName) : m_presetNumber(presetNumber), m_frequency(frequency), m_stationName(stationName) {}
    int presetNumber() const { return m_presetNumber; }
    void setPresetNumber(int presetNumber) { if (presetNumber != m_presetNumber) { m_presetNumber = presetNumber; } }
    float frequency() const { return m_frequency; }
    void setFrequency(float frequency) { if (frequency != m_frequency) { m_frequency = frequency; } }
    QString stationName() const { return m_stationName; }
    void setStationName(QString stationName) { if (stationName != m_stationName) { m_stationName = stationName; } }
private:
    int m_presetNumber;
    float m_frequency;
    QString m_stationName;
};

inline bool operator==(const PresetInfo &left, const PresetInfo &right) Q_DECL_NOTHROW {
    return left.presetNumber() == right.presetNumber() && left.frequency() == right.frequency() && left.stationName() == right.stationName();
}
inline bool operator!=(const PresetInfo &left, const PresetInfo &right) Q_DECL_NOTHROW {
    return !(left == right);
}

inline QDebug operator<<(QDebug dbg, const PresetInfo &obj) {
    dbg.nospace() << "PresetInfo("  << "presetNumber: " << obj.presetNumber() << ", " << "frequency: " << obj.frequency() << ", " << "stationName: " << obj.stationName() << ")";
    return dbg.maybeSpace();
}

inline QDataStream &operator<<(QDataStream &ds, const PresetInfo &obj) {
    QtRemoteObjects::copyStoredProperties(&obj, ds);
    return ds;
}

inline QDataStream &operator>>(QDataStream &ds, PresetInfo &obj) {
    QtRemoteObjects::copyStoredProperties(ds, &obj);
    return ds;
}

class MinuteTimerSource : public QObject
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "MinuteTimer")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "0a4c8f970f7fb60b1801ee52d582f3aceedcd902")
    Q_PROPERTY(int hour READ hour WRITE setHour NOTIFY hourChanged)
    Q_PROPERTY(int minute READ minute WRITE setMinute NOTIFY minuteChanged)

public:
    explicit MinuteTimerSource(QObject *parent = nullptr) : QObject(parent)
    {
        qRegisterMetaType<PresetInfo>();
        qRegisterMetaType<PresetInfo>();
        qRegisterMetaType<QMap<QString, QString>>();

    }

public:
    ~MinuteTimerSource() override = default;

    virtual int hour() const = 0;
    virtual int minute() const = 0;
    virtual void setHour(int hour) = 0;
    virtual void setMinute(int minute) = 0;

Q_SIGNALS:
    void hourChanged(int hour);
    void minuteChanged(int minute);
    void timeChanged();
    void timeChanged2(QTime t);
    void sendCustom(PresetInfo info);
    void foo(QMap<QString, QString> foo);

public Q_SLOTS:
    virtual void pushHour(int hour)
    {
        setHour(hour);
    }
    virtual void pushMinute(int minute)
    {
        setMinute(minute);
    }
    virtual void SetTimeZone(const int & __repc_variable_1) = 0;

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};

class MinuteTimerSimpleSource : public MinuteTimerSource
{
    Q_OBJECT

public:
    explicit MinuteTimerSimpleSource(QObject *parent = nullptr) : MinuteTimerSource(parent)
    , m_hour(1)
    , m_minute(51)
    {
    }

public:
    ~MinuteTimerSimpleSource() override = default;

    int hour() const override { return m_hour; }
    int minute() const override { return m_minute; }
    void setHour(int hour) override
    {
        if (hour != m_hour) {
            m_hour = hour;
            Q_EMIT hourChanged(m_hour);
        }
    }
    void setMinute(int minute) override
    {
        if (minute != m_minute) {
            m_minute = minute;
            Q_EMIT minuteChanged(m_minute);
        }
    }

private:
    int m_hour;
    int m_minute;
};

template <class ObjectType>
struct MinuteTimerSourceAPI : public SourceApiMap
{
    MinuteTimerSourceAPI(ObjectType *object, const QString &name = QLatin1String("MinuteTimer"))
        : SourceApiMap(), m_name(name)
    {
        Q_UNUSED(object)
        m_enums[0] = 0;
        m_properties[0] = 2;
        m_properties[1] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::hour, static_cast<int (QObject::*)()>(nullptr),"hour");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::hourChanged, static_cast<void (QObject::*)()>(nullptr));
        m_properties[2] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::minute, static_cast<int (QObject::*)()>(nullptr),"minute");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::minuteChanged, static_cast<void (QObject::*)()>(nullptr));
        m_signals[0] = 6;
        m_signals[1] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::hourChanged, static_cast<void(QObject::*)(int)>(nullptr),m_signalArgCount+0,&m_signalArgTypes[0]);
        m_signals[2] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::minuteChanged, static_cast<void(QObject::*)(int)>(nullptr),m_signalArgCount+1,&m_signalArgTypes[1]);
        m_signals[3] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::timeChanged, static_cast<void (QObject::*)()>(nullptr),m_signalArgCount+2,&m_signalArgTypes[2]);
        m_signals[4] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::timeChanged2, static_cast<void (QObject::*)(QTime)>(nullptr),m_signalArgCount+3,&m_signalArgTypes[3]);
        m_signals[5] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::sendCustom, static_cast<void (QObject::*)(PresetInfo)>(nullptr),m_signalArgCount+4,&m_signalArgTypes[4]);
        m_signals[6] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::foo, static_cast<void (QObject::*)(QMap<QString,QString>)>(nullptr),m_signalArgCount+5,&m_signalArgTypes[5]);
        m_methods[0] = 3;
        m_methods[1] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushHour, static_cast<void (QObject::*)(int)>(nullptr),"pushHour(int)",m_methodArgCount+0,&m_methodArgTypes[0]);
        m_methods[2] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushMinute, static_cast<void (QObject::*)(int)>(nullptr),"pushMinute(int)",m_methodArgCount+1,&m_methodArgTypes[1]);
        m_methods[3] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::SetTimeZone, static_cast<void (QObject::*)(int)>(nullptr),"SetTimeZone(int)",m_methodArgCount+2,&m_methodArgTypes[2]);
    }

    QString name() const override { return m_name; }
    QString typeName() const override { return QStringLiteral("MinuteTimer"); }
    int enumCount() const override { return m_enums[0]; }
    int propertyCount() const override { return m_properties[0]; }
    int signalCount() const override { return m_signals[0]; }
    int methodCount() const override { return m_methods[0]; }
    int sourceEnumIndex(int index) const override
    {
        if (index < 0 || index >= m_enums[0] || index + 1 >= int(std::size(m_enums)))
            return -1;
        return m_enums[index+1];
    }
    int sourcePropertyIndex(int index) const override
    {
        if (index < 0 || index >= m_properties[0] || index + 1 >= int(std::size(m_properties)))
            return -1;
        return m_properties[index+1];
    }
    int sourceSignalIndex(int index) const override
    {
        if (index < 0 || index >= m_signals[0] || index + 1 >= int(std::size(m_signals)))
            return -1;
        return m_signals[index+1];
    }
    int sourceMethodIndex(int index) const override
    {
        if (index < 0 || index >= m_methods[0] || index + 1 >= int(std::size(m_methods)))
            return -1;
        return m_methods[index+1];
    }
    int signalParameterCount(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signalArgCount[index];
    }
    int signalParameterType(int sigIndex, int paramIndex) const override
    {
        if (sigIndex < 0 || sigIndex >= m_signals[0] || paramIndex < 0 || paramIndex >= m_signalArgCount[sigIndex])
            return -1;
        return m_signalArgTypes[sigIndex][paramIndex];
    }
    int methodParameterCount(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methodArgCount[index];
    }
    int methodParameterType(int methodIndex, int paramIndex) const override
    {
        if (methodIndex < 0 || methodIndex >= m_methods[0] || paramIndex < 0 || paramIndex >= m_methodArgCount[methodIndex])
            return -1;
        return m_methodArgTypes[methodIndex][paramIndex];
    }
    int propertyIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return m_properties[1];
        case 1: return m_properties[2];
        }
        return -1;
    }
    int propertyRawIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return 0;
        case 1: return 1;
        }
        return -1;
    }
    const QByteArray signalSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("hourChanged(int)");
        case 1: return QByteArrayLiteral("minuteChanged(int)");
        case 2: return QByteArrayLiteral("timeChanged()");
        case 3: return QByteArrayLiteral("timeChanged2(QTime)");
        case 4: return QByteArrayLiteral("sendCustom(PresetInfo)");
        case 5: return QByteArrayLiteral("foo(QMap<QString,QString>)");
        }
        return QByteArrayLiteral("");
    }
    QByteArrayList signalParameterNames(int index) const override
    {
        if (index < 0 || index >= m_signals[0] || index + 1 >= int(std::size(m_signals)))
            return QByteArrayList();
        return ObjectType::staticMetaObject.method(m_signals[index + 1]).parameterNames();
    }
    const QByteArray methodSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("pushHour(int)");
        case 1: return QByteArrayLiteral("pushMinute(int)");
        case 2: return QByteArrayLiteral("SetTimeZone(int)");
        }
        return QByteArrayLiteral("");
    }
    QMetaMethod::MethodType methodType(int) const override
    {
        return QMetaMethod::Slot;
    }
    QByteArrayList methodParameterNames(int index) const override
    {
        if (index < 0 || index >= m_methods[0] || index + 1 >= int(std::size(m_methods)))
            return QByteArrayList();
        return ObjectType::staticMetaObject.method(m_methods[index + 1]).parameterNames();
    }
    const QByteArray typeName(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("void");
        case 1: return QByteArrayLiteral("void");
        case 2: return QByteArrayLiteral("void");
        }
        return QByteArrayLiteral("");
    }
    QByteArray objectSignature() const override { return QByteArray{"0a4c8f970f7fb60b1801ee52d582f3aceedcd902"}; }

    int m_enums[1];
    int m_properties[3];
    int m_signals[7];
    int m_methods[4];
    const QString m_name;
    int m_signalArgCount[6];
    const int* m_signalArgTypes[6];
    int m_methodArgCount[3];
    const int* m_methodArgTypes[3];
};


#endif // REP_TIMEMODEL_SOURCE_H
