#ifndef REP_SIMPLESWITCH_SOURCE_H
#define REP_SIMPLESWITCH_SOURCE_H

// This is an autogenerated file.
// Do not edit this file, any changes made will be lost the next time it is generated.

#include <QtCore/qobject.h>
#include <QtCore/qdatastream.h>
#include <QtCore/qvariant.h>
#include <QtCore/qmap.h>
#include <QtCore/qmetatype.h>

#include <QtRemoteObjects/qremoteobjectnode.h>
#include <QtRemoteObjects/qremoteobjectsource.h>

#include <QtCore>

using namespace Qt::Literals::StringLiterals;

class SimpleSwitchSource : public QObject
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "SimpleSwitch")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "848df11717af2d8be5106a80a701bfc5723baba7")
    Q_PROPERTY(bool currState READ currState WRITE setCurrState NOTIFY currStateChanged)

public:
    explicit SimpleSwitchSource(QObject *parent = nullptr) : QObject(parent)
    {
    }

public:
    ~SimpleSwitchSource() override = default;

    virtual bool currState() const = 0;
    virtual void setCurrState(bool currState) = 0;

Q_SIGNALS:
    void currStateChanged(bool currState);

public Q_SLOTS:
    virtual void pushCurrState(bool currState)
    {
        setCurrState(currState);
    }
    virtual void server_slot(bool clientState) = 0;

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};

class SimpleSwitchSimpleSource : public SimpleSwitchSource
{
    Q_OBJECT

public:
    explicit SimpleSwitchSimpleSource(QObject *parent = nullptr) : SimpleSwitchSource(parent)
    , m_currState(false)
    {
    }

public:
    ~SimpleSwitchSimpleSource() override = default;

    bool currState() const override { return m_currState; }
    void setCurrState(bool currState) override
    {
        if (currState != m_currState) {
            m_currState = currState;
            Q_EMIT currStateChanged(m_currState);
        }
    }

private:
    bool m_currState;
};

template <class ObjectType>
struct SimpleSwitchSourceAPI : public SourceApiMap
{
    SimpleSwitchSourceAPI(ObjectType *object, const QString &name = QLatin1String("SimpleSwitch"))
        : SourceApiMap(), m_name(name)
    {
        Q_UNUSED(object)
        m_enums[0] = 0;
        m_properties[0] = 1;
        m_properties[1] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::currState, static_cast<bool (QObject::*)()>(nullptr),"currState");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::currStateChanged, static_cast<void (QObject::*)()>(nullptr));
        m_signals[0] = 1;
        m_signals[1] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::currStateChanged, static_cast<void(QObject::*)(bool)>(nullptr),m_signalArgCount+0,&m_signalArgTypes[0]);
        m_methods[0] = 2;
        m_methods[1] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushCurrState, static_cast<void (QObject::*)(bool)>(nullptr),"pushCurrState(bool)",m_methodArgCount+0,&m_methodArgTypes[0]);
        m_methods[2] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::server_slot, static_cast<void (QObject::*)(bool)>(nullptr),"server_slot(bool)",m_methodArgCount+1,&m_methodArgTypes[1]);
    }

    QString name() const override { return m_name; }
    QString typeName() const override { return QStringLiteral("SimpleSwitch"); }
    int enumCount() const override { return m_enums[0]; }
    int propertyCount() const override { return m_properties[0]; }
    int signalCount() const override { return m_signals[0]; }
    int methodCount() const override { return m_methods[0]; }
    int sourceEnumIndex(int index) const override
    {
        if (index < 0 || index >= m_enums[0] || index + 1 >= int(std::size(m_enums)))
            return -1;
        return m_enums[index+1];
    }
    int sourcePropertyIndex(int index) const override
    {
        if (index < 0 || index >= m_properties[0] || index + 1 >= int(std::size(m_properties)))
            return -1;
        return m_properties[index+1];
    }
    int sourceSignalIndex(int index) const override
    {
        if (index < 0 || index >= m_signals[0] || index + 1 >= int(std::size(m_signals)))
            return -1;
        return m_signals[index+1];
    }
    int sourceMethodIndex(int index) const override
    {
        if (index < 0 || index >= m_methods[0] || index + 1 >= int(std::size(m_methods)))
            return -1;
        return m_methods[index+1];
    }
    int signalParameterCount(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signalArgCount[index];
    }
    int signalParameterType(int sigIndex, int paramIndex) const override
    {
        if (sigIndex < 0 || sigIndex >= m_signals[0] || paramIndex < 0 || paramIndex >= m_signalArgCount[sigIndex])
            return -1;
        return m_signalArgTypes[sigIndex][paramIndex];
    }
    int methodParameterCount(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methodArgCount[index];
    }
    int methodParameterType(int methodIndex, int paramIndex) const override
    {
        if (methodIndex < 0 || methodIndex >= m_methods[0] || paramIndex < 0 || paramIndex >= m_methodArgCount[methodIndex])
            return -1;
        return m_methodArgTypes[methodIndex][paramIndex];
    }
    int propertyIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return m_properties[1];
        }
        return -1;
    }
    int propertyRawIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return 0;
        }
        return -1;
    }
    const QByteArray signalSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("currStateChanged(bool)");
        }
        return QByteArrayLiteral("");
    }
    QByteArrayList signalParameterNames(int index) const override
    {
        if (index < 0 || index >= m_signals[0] || index + 1 >= int(std::size(m_signals)))
            return QByteArrayList();
        return ObjectType::staticMetaObject.method(m_signals[index + 1]).parameterNames();
    }
    const QByteArray methodSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("pushCurrState(bool)");
        case 1: return QByteArrayLiteral("server_slot(bool)");
        }
        return QByteArrayLiteral("");
    }
    QMetaMethod::MethodType methodType(int) const override
    {
        return QMetaMethod::Slot;
    }
    QByteArrayList methodParameterNames(int index) const override
    {
        if (index < 0 || index >= m_methods[0] || index + 1 >= int(std::size(m_methods)))
            return QByteArrayList();
        return ObjectType::staticMetaObject.method(m_methods[index + 1]).parameterNames();
    }
    const QByteArray typeName(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("void");
        case 1: return QByteArrayLiteral("void");
        }
        return QByteArrayLiteral("");
    }
    QByteArray objectSignature() const override { return QByteArray{"848df11717af2d8be5106a80a701bfc5723baba7"}; }

    int m_enums[1];
    int m_properties[2];
    int m_signals[2];
    int m_methods[3];
    const QString m_name;
    int m_signalArgCount[1];
    const int* m_signalArgTypes[1];
    int m_methodArgCount[2];
    const int* m_methodArgTypes[2];
};


#endif // REP_SIMPLESWITCH_SOURCE_H
